// Demo of auto boxing or unboxing of Integer and int
import java.util.ArrayList;
public class AutoPugilism{
  public static void main(String args[]){
    int lilI = 42;
    Integer bigI = new Integer(lilI); // manual construction
    lilI = bigI.intValue();	      // manual conversion

    bigI = 42;			// Silent conversion: boxing
    bigI = lilI;		// Silent conversion: boxing
    lilI = bigI;		// Silent conversion: unboxing

    // Compiler reject!
    // ArrayList<int> al = new ArrayList<int>();

    ArrayList<Integer> al = new ArrayList<Integer>();
    al.add(new Integer(42));	// proper
    al.add(42);			// silent conversion: boxing
    al.add(lilI);		// silent conversion: boxing
    al.add(bigI);		// proper

    Integer adultI = al.get(1); // proper 
    int babyI = al.get(1);      // silent conversion: unboxing
  }
}
